
/**
 * This is a generated class and is not intended for modification.  
 */
package valueObjects
{
import com.adobe.fiber.styles.IStyle;
import com.adobe.fiber.styles.Style;
import com.adobe.fiber.styles.StyleValidator;
import com.adobe.fiber.valueobjects.AbstractEntityMetadata;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import mx.events.ValidationResultEvent;
import valueObjects.Elementaliste;
import valueObjects.Voleur;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IModelType;
import mx.events.PropertyChangeEvent;

use namespace model_internal;

[ExcludeClass]
internal class _ClassesEntityMetadata extends com.adobe.fiber.valueobjects.AbstractEntityMetadata
{
    private static var emptyArray:Array = new Array();

    model_internal static var allProperties:Array = new Array("voleur", "elementaliste");
    model_internal static var allAssociationProperties:Array = new Array();
    model_internal static var allRequiredProperties:Array = new Array("voleur", "elementaliste");
    model_internal static var allAlwaysAvailableProperties:Array = new Array("voleur", "elementaliste");
    model_internal static var guardedProperties:Array = new Array();
    model_internal static var dataProperties:Array = new Array("voleur", "elementaliste");
    model_internal static var sourceProperties:Array = emptyArray
    model_internal static var nonDerivedProperties:Array = new Array("voleur", "elementaliste");
    model_internal static var derivedProperties:Array = new Array();
    model_internal static var collectionProperties:Array = new Array();
    model_internal static var collectionBaseMap:Object;
    model_internal static var entityName:String = "Classes";
    model_internal static var dependentsOnMap:Object;
    model_internal static var dependedOnServices:Array = new Array();
    model_internal static var propertyTypeMap:Object;

    
    model_internal var _voleurIsValid:Boolean;
    model_internal var _voleurValidator:com.adobe.fiber.styles.StyleValidator;
    model_internal var _voleurIsValidCacheInitialized:Boolean = false;
    model_internal var _voleurValidationFailureMessages:Array;
    
    model_internal var _elementalisteIsValid:Boolean;
    model_internal var _elementalisteValidator:com.adobe.fiber.styles.StyleValidator;
    model_internal var _elementalisteIsValidCacheInitialized:Boolean = false;
    model_internal var _elementalisteValidationFailureMessages:Array;

    model_internal var _instance:_Super_Classes;
    model_internal static var _nullStyle:com.adobe.fiber.styles.Style = new com.adobe.fiber.styles.Style();

    public function _ClassesEntityMetadata(value : _Super_Classes)
    {
        // initialize property maps
        if (model_internal::dependentsOnMap == null)
        {
            // dependents map
            model_internal::dependentsOnMap = new Object();
            model_internal::dependentsOnMap["voleur"] = new Array();
            model_internal::dependentsOnMap["elementaliste"] = new Array();

            // collection base map
            model_internal::collectionBaseMap = new Object();
        }

        // Property type Map
        model_internal::propertyTypeMap = new Object();
        model_internal::propertyTypeMap["voleur"] = "valueObjects.Voleur";
        model_internal::propertyTypeMap["elementaliste"] = "valueObjects.Elementaliste";

        model_internal::_instance = value;
        model_internal::_voleurValidator = new StyleValidator(model_internal::_instance.model_internal::_doValidationForVoleur);
        model_internal::_voleurValidator.required = true;
        model_internal::_voleurValidator.requiredFieldError = "voleur is required";
        //model_internal::_voleurValidator.source = model_internal::_instance;
        //model_internal::_voleurValidator.property = "voleur";
        model_internal::_elementalisteValidator = new StyleValidator(model_internal::_instance.model_internal::_doValidationForElementaliste);
        model_internal::_elementalisteValidator.required = true;
        model_internal::_elementalisteValidator.requiredFieldError = "elementaliste is required";
        //model_internal::_elementalisteValidator.source = model_internal::_instance;
        //model_internal::_elementalisteValidator.property = "elementaliste";
    }

    override public function getEntityName():String
    {
        return model_internal::entityName;
    }

    override public function getProperties():Array
    {
        return model_internal::allProperties;
    }

    override public function getAssociationProperties():Array
    {
        return model_internal::allAssociationProperties;
    }

    override public function getRequiredProperties():Array
    {
         return model_internal::allRequiredProperties;   
    }

    override public function getDataProperties():Array
    {
        return model_internal::dataProperties;
    }

    public function getSourceProperties():Array
    {
        return model_internal::sourceProperties;
    }

    public function getNonDerivedProperties():Array
    {
        return model_internal::nonDerivedProperties;
    }

    override public function getGuardedProperties():Array
    {
        return model_internal::guardedProperties;
    }

    override public function getUnguardedProperties():Array
    {
        return model_internal::allAlwaysAvailableProperties;
    }

    override public function getDependants(propertyName:String):Array
    {
       if (model_internal::nonDerivedProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a data property of entity Classes");
            
       return model_internal::dependentsOnMap[propertyName] as Array;  
    }

    override public function getDependedOnServices():Array
    {
        return model_internal::dependedOnServices;
    }

    override public function getCollectionProperties():Array
    {
        return model_internal::collectionProperties;
    }

    override public function getCollectionBase(propertyName:String):String
    {
        if (model_internal::collectionProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a collection property of entity Classes");

        return model_internal::collectionBaseMap[propertyName];
    }
    
    override public function getPropertyType(propertyName:String):String
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a property of Classes");

        return model_internal::propertyTypeMap[propertyName];
    }

    override public function getAvailableProperties():com.adobe.fiber.valueobjects.IPropertyIterator
    {
        return new com.adobe.fiber.valueobjects.AvailablePropertyIterator(this);
    }

    override public function getValue(propertyName:String):*
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " does not exist for entity Classes");
        }

        return model_internal::_instance[propertyName];
    }

    override public function setValue(propertyName:String, value:*):void
    {
        if (model_internal::nonDerivedProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " is not a modifiable property of entity Classes");
        }

        model_internal::_instance[propertyName] = value;
    }

    override public function getMappedByProperty(associationProperty:String):String
    {
        switch(associationProperty)
        {
            default:
            {
                return null;
            }
        }
    }

    override public function getPropertyLength(propertyName:String):int
    {
        switch(propertyName)
        {
            default:
            {
                return 0;
            }
        }
    }

    override public function isAvailable(propertyName:String):Boolean
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " does not exist for entity Classes");
        }

        if (model_internal::allAlwaysAvailableProperties.indexOf(propertyName) != -1)
        {
            return true;
        }

        switch(propertyName)
        {
            default:
            {
                return true;
            }
        }
    }

    override public function getIdentityMap():Object
    {
        var returnMap:Object = new Object();

        return returnMap;
    }

    [Bindable(event="propertyChange")]
    override public function get invalidConstraints():Array
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_invalidConstraints;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_invalidConstraints;        
        }
    }

    [Bindable(event="propertyChange")]
    override public function get validationFailureMessages():Array
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_validationFailureMessages;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_validationFailureMessages;
        }
    }

    override public function getDependantInvalidConstraints(propertyName:String):Array
    {
        var dependants:Array = getDependants(propertyName);
        if (dependants.length == 0)
        {
            return emptyArray;
        }

        var currentlyInvalid:Array = invalidConstraints;
        if (currentlyInvalid.length == 0)
        {
            return emptyArray;
        }

        var filterFunc:Function = function(element:*, index:int, arr:Array):Boolean
        {
            return dependants.indexOf(element) > -1;
        }

        return currentlyInvalid.filter(filterFunc);
    }

    /**
     * isValid
     */
    [Bindable(event="propertyChange")] 
    public function get isValid() : Boolean
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_isValid;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_isValid;
        }
    }

    [Bindable(event="propertyChange")]
    public function get isVoleurAvailable():Boolean
    {
        return true;
    }

    [Bindable(event="propertyChange")]
    public function get isElementalisteAvailable():Boolean
    {
        return true;
    }


    /**
     * derived property recalculation
     */
    public function invalidateDependentOnVoleur():void
    {
        if (model_internal::_voleurIsValidCacheInitialized )
        {
            model_internal::_instance.model_internal::_doValidationCacheOfVoleur = null;
            model_internal::calculateVoleurIsValid();
        }
    }
    public function invalidateDependentOnElementaliste():void
    {
        if (model_internal::_elementalisteIsValidCacheInitialized )
        {
            model_internal::_instance.model_internal::_doValidationCacheOfElementaliste = null;
            model_internal::calculateElementalisteIsValid();
        }
    }

    model_internal function fireChangeEvent(propertyName:String, oldValue:Object, newValue:Object):void
    {
        this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, propertyName, oldValue, newValue));
    }

    [Bindable(event="propertyChange")]   
    public function get voleurStyle():com.adobe.fiber.styles.Style
    {
        return model_internal::_nullStyle;
    }

    public function get voleurValidator() : StyleValidator
    {
        return model_internal::_voleurValidator;
    }

    model_internal function set _voleurIsValid_der(value:Boolean):void 
    {
        var oldValue:Boolean = model_internal::_voleurIsValid;         
        if (oldValue !== value)
        {
            model_internal::_voleurIsValid = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "voleurIsValid", oldValue, value));
        }                             
    }

    [Bindable(event="propertyChange")]
    public function get voleurIsValid():Boolean
    {
        if (!model_internal::_voleurIsValidCacheInitialized)
        {
            model_internal::calculateVoleurIsValid();
        }

        return model_internal::_voleurIsValid;
    }

    model_internal function calculateVoleurIsValid():void
    {
        var valRes:ValidationResultEvent = model_internal::_voleurValidator.validate(model_internal::_instance.voleur)
        model_internal::_voleurIsValid_der = (valRes.results == null);
        model_internal::_voleurIsValidCacheInitialized = true;
        if (valRes.results == null)
             model_internal::voleurValidationFailureMessages_der = emptyArray;
        else
        {
            var _valFailures:Array = new Array();
            for (var a:int = 0 ; a<valRes.results.length ; a++)
            {
                _valFailures.push(valRes.results[a].errorMessage);
            }
            model_internal::voleurValidationFailureMessages_der = _valFailures;
        }
    }

    [Bindable(event="propertyChange")]
    public function get voleurValidationFailureMessages():Array
    {
        if (model_internal::_voleurValidationFailureMessages == null)
            model_internal::calculateVoleurIsValid();

        return _voleurValidationFailureMessages;
    }

    model_internal function set voleurValidationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_voleurValidationFailureMessages;

        var needUpdate : Boolean = false;
        if (oldValue == null)
            needUpdate = true;
    
        // avoid firing the event when old and new value are different empty arrays
        if (!needUpdate && (oldValue !== value && (oldValue.length > 0 || value.length > 0)))
        {
            if (oldValue.length == value.length)
            {
                for (var a:int=0; a < oldValue.length; a++)
                {
                    if (oldValue[a] !== value[a])
                    {
                        needUpdate = true;
                        break;
                    }
                }
            }
            else
            {
                needUpdate = true;
            }
        }

        if (needUpdate)
        {
            model_internal::_voleurValidationFailureMessages = value;   
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "voleurValidationFailureMessages", oldValue, value));
            // Only execute calculateIsValid if it has been called before, to update the validationFailureMessages for
            // the entire entity.
            if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
            {
                model_internal::_instance.model_internal::isValid_der = model_internal::_instance.model_internal::calculateIsValid();
            }
        }
    }

    [Bindable(event="propertyChange")]   
    public function get elementalisteStyle():com.adobe.fiber.styles.Style
    {
        return model_internal::_nullStyle;
    }

    public function get elementalisteValidator() : StyleValidator
    {
        return model_internal::_elementalisteValidator;
    }

    model_internal function set _elementalisteIsValid_der(value:Boolean):void 
    {
        var oldValue:Boolean = model_internal::_elementalisteIsValid;         
        if (oldValue !== value)
        {
            model_internal::_elementalisteIsValid = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "elementalisteIsValid", oldValue, value));
        }                             
    }

    [Bindable(event="propertyChange")]
    public function get elementalisteIsValid():Boolean
    {
        if (!model_internal::_elementalisteIsValidCacheInitialized)
        {
            model_internal::calculateElementalisteIsValid();
        }

        return model_internal::_elementalisteIsValid;
    }

    model_internal function calculateElementalisteIsValid():void
    {
        var valRes:ValidationResultEvent = model_internal::_elementalisteValidator.validate(model_internal::_instance.elementaliste)
        model_internal::_elementalisteIsValid_der = (valRes.results == null);
        model_internal::_elementalisteIsValidCacheInitialized = true;
        if (valRes.results == null)
             model_internal::elementalisteValidationFailureMessages_der = emptyArray;
        else
        {
            var _valFailures:Array = new Array();
            for (var a:int = 0 ; a<valRes.results.length ; a++)
            {
                _valFailures.push(valRes.results[a].errorMessage);
            }
            model_internal::elementalisteValidationFailureMessages_der = _valFailures;
        }
    }

    [Bindable(event="propertyChange")]
    public function get elementalisteValidationFailureMessages():Array
    {
        if (model_internal::_elementalisteValidationFailureMessages == null)
            model_internal::calculateElementalisteIsValid();

        return _elementalisteValidationFailureMessages;
    }

    model_internal function set elementalisteValidationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_elementalisteValidationFailureMessages;

        var needUpdate : Boolean = false;
        if (oldValue == null)
            needUpdate = true;
    
        // avoid firing the event when old and new value are different empty arrays
        if (!needUpdate && (oldValue !== value && (oldValue.length > 0 || value.length > 0)))
        {
            if (oldValue.length == value.length)
            {
                for (var a:int=0; a < oldValue.length; a++)
                {
                    if (oldValue[a] !== value[a])
                    {
                        needUpdate = true;
                        break;
                    }
                }
            }
            else
            {
                needUpdate = true;
            }
        }

        if (needUpdate)
        {
            model_internal::_elementalisteValidationFailureMessages = value;   
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "elementalisteValidationFailureMessages", oldValue, value));
            // Only execute calculateIsValid if it has been called before, to update the validationFailureMessages for
            // the entire entity.
            if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
            {
                model_internal::_instance.model_internal::isValid_der = model_internal::_instance.model_internal::calculateIsValid();
            }
        }
    }


     /**
     * 
     * @inheritDoc 
     */ 
     override public function getStyle(propertyName:String):com.adobe.fiber.styles.IStyle
     {
         switch(propertyName)
         {
            default:
            {
                return null;
            }
         }
     }
     
     /**
     * 
     * @inheritDoc 
     *  
     */  
     override public function getPropertyValidationFailureMessages(propertyName:String):Array
     {
         switch(propertyName)
         {
            case("voleur"):
            {
                return voleurValidationFailureMessages;
            }
            case("elementaliste"):
            {
                return elementalisteValidationFailureMessages;
            }
            default:
            {
                return emptyArray;
            }
         }
     }

}

}
